/*(C) 2008-2011 Advanced Micro Devices, Inc. All Rights Reserved.
 *  
 *  This file is part of AMD LibM 3.0.
 *  
 *  AMD LibM 3.0 is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *  
 *  AMD LibM 3.0 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *  
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with AMD LibM 3.0.  If not, see
 *  <http://www.gnu.org/licenses/>.
 */
 
 


#ifndef __LIBM_SPECIAL_H__
#define __LIBM_SPECIAL_H__

#include <math.h>
#include <libm_errno_amd.h>

double _amd_handle_error(
        const char *fname,
        int opcode,
        unsigned long long value,
        int type,
        int flags,
        int error,
        double arg1,
        double arg2,
        int nargs
        );

float _amd_handle_errorf(
        const char *fname,
        int opcode,
        unsigned long long value,
        int type,
        int flags,
        int error,
        float arg1,
        float arg2,
        int nargs
        );



typedef enum {
    _AMD_FPCodeUnspecified,
    _AMD_FPCodeSquareRoot,
    _AMD_FPCodeRemainder,
    _AMD_FPCodeRound,
    _AMD_FPCodeFloor,
    _AMD_FPCodeCeil,
    _AMD_FPCodeAcos,
    _AMD_FPCodeAsin,
    _AMD_FPCodeAtan,
    _AMD_FPCodeAtan2,
    _AMD_FPCodeCabs,
    _AMD_FPCodeCos,
    _AMD_FPCodeCosh,
    _AMD_FPCodeExp,
    _AMD_FPCodeFabs,
    _AMD_FPCodeFmod,
    _AMD_FPCodeFrexp,
    _AMD_FPCodeHypot,
    _AMD_FPCodeLdexp,
    _AMD_FPCodeLog,
    _AMD_FPCodeLog10,
    _AMD_FPCodeModf,
    _AMD_FPCodePow,
    _AMD_FPCodeSin,
    _AMD_FPCodeSinh,
    _AMD_FPCodeTan,
    _AMD_FPCodeTanh,
    _AMD_FPCodeLogb,
    _AMD_FPCodeNextafter,
    _AMD_FPCodeFmin,         
    _AMD_FPCodeFmax,        
    _AMD_FPCodeAsinh,
    _AMD_FPCodeAcosh,
    _AMD_FPCodeAtanh,
    _AMD_FPCodeTruncate,    
    _AMD_FPCodeCbrt,
    _AMD_FPCodeExp10,
    _AMD_FPCodeExp2,
    _AMD_FPCodeExpm1,
    _AMD_FPCodeLrint,
    _AMD_FPCodeRint,
    _AMD_FPCodeNexttoward,
    _AMD_FPCodeNearbyint,
    _AMD_FPCodeFdim,
    _AMD_FPCodeFinite,
    _AMD_FPCodeScalbn,
    _AMD_FPCodeScalbln,
    _AMD_FPCodeLog1p,
    _AMD_FPCodeLog2,
    _AMD_FPCodeLlrint,
    _AMD_FPCodeLlround,
    _AMD_FPCodeLround,
    _AMD_FPCodeRemquo,
    _AMD_FPCodeFma
} _AMD_FP_OP_CODE;

#define _DOMAIN     1 
#define _SING       2 
#define _OVERFLOW   3 
#define _UNDERFLOW  4 
#define _TLOSS      5 
#define _PLOSS      6 

#endif // __LIBM_SPECIAL_H__


